<?php

namespace InSegment\WorkersFramework\Console\Commands;

use Shavshukov\EventAppBase\Console\AppCommand;

use InSegment\WorkersFramework\Providers\QueueConnectionServiceProvider;
use InSegment\WorkersFramework\Interfaces\QueueDriverInterface;
use InSegment\WorkersFramework\Services\Manager;

class Manage extends AppCommand
{
    
    /**
     * {@inheritDoc}
     */
    public function usage(): string
    {
        return 'Manage the queue service: run workers and a web server';
    }

    /**
     * {@inheritDoc}
     */
    public function handle(array $arguments)
    {
        $this->app->registerProviders([
            new QueueConnectionServiceProvider($this->app),
        ], $this->app);
        
        return $this->app->service('queue-driver')->then(function (QueueDriverInterface $queueDriver) {
            return (new Manager($this->app, $queueDriver))->manage();
        });
    }

    /**
     * {@inheritDoc}
     */
    public function help(string $entryFileName): string
    {
        return implode("\n", [
            "Usage: {$entryFileName} manage\n",
            'Manage the queue service: run workers and a web server'
        ]);
    }

}
