<?php

namespace InSegment\WorkersFramework\Interfaces;

interface JobInterface
{
    /**
     * Get name of the job
     * 
     * @return string
     */
    public function getName();
    
    /**
     * Get weight of the job in conventional units
     * 
     * @return int
     */
    public function getWeight(): int;
    
    /**
     * Process the message
     * 
     * @param \InSegment\WorkersFramework\Interfaces\QueueMessageInterface $message
     * @return mixed
     */
    public function process(QueueMessageInterface $message);
}
