<?php

namespace InSegment\WorkersFramework\Interfaces;

use Shavshukov\EventAppBase\Interfaces\ModelInterface;

interface QueueMessageInterface
{
    /**
     * Get consumer tag of the message
     * 
     * @return string|null
     */
    public function getConsumerTag(): ?string;
    
    /**
     * Get contents of the message
     * 
     * @return string
     */
    public function getContents(): string;
    
    /**
     * Get additional headers that come with the message
     * 
     * @return \Shavshukov\EventAppBase\Interfaces\ModelInterface
     */
    public function getHeaders(): ModelInterface;
    
    /**
     * Get name of the queue this message came from
     * 
     * @return string
     */
    public function getQueueName(): string;
    
    /**
     * Mark queue message as successfully processed and remove from further processing
     * 
     * @return boolean|\React\Promise\PromiseInterface
     */
    public function acknowlege();
}
