<?php

namespace InSegment\WorkersFramework\Models;

use Shavshukov\EventAppBase\Model\ArrayModel;

class QueueConfig extends ArrayModel
{
    
    /**
     * Mandatory fields
     *
     * @var array
     */
    protected $mandatoryFields = ['queueName', 'serviceQueueName'];
    
    /**
     * Constructor
     * 
     * @param array $data
     */
    public function __construct(array $data)
    {
        $this->data = $data;
    }
    
    /**
     * Checks the configuration and throws an error should it fail
     * 
     * @return null
     * @throws \Exception
     */
    public function check()
    {
        $validation = $this->validate();
        
        if (!$validation->isValid()) {
            $printNotFoundFields = implode(', ', $validation->getInvalidFields());
            throw new \Exception("Queue configuration mandatory fields not found: {$printNotFoundFields}");
        }
    }
    
}
